# nacteme matematickou a numerickou knihovnu
import math
import numpy as np

# kolik bodu budeme generovat
pocet = 1000000
# pole (matice) nahodnych cisel, ktera ma "pocet" radku a 2 sloupce,
# pricemz kazdy radek predstavuje souradnice theta a x udavajici
# natoceni a polohu stredu jehly
n = np.random.rand(pocet,2)
n[:,0] -= 0.5
n[:,0] *= math.pi
n[:,1] *= 0.5
# inicializace promenne, do niz budeme ukladat pocet protnuti
pocet_uvnitr = 0

# cyklus, ktery prochazi cisla od 0 do pocet-1
for i in range(0,pocet):
    # v hranate zavorce piseme radkovy a sloupcovy index oddeleny carkou,
    # pomoci podminky ze serialu kontrolujeme, ze doslo k protnuti
    x = n[i,1]
    thet = n[i,0]
    x_konec = x - 0.5*math.cos(thet)
    if x_konec < 0:
        # pokud je podminka splnena, zvysime pocet protnuti o jedna
        pocet_uvnitr += 1

# vypocet prumeru; ve jmenovateli je prictena nula, aby byl vysledek float
prumer = pocet_uvnitr/(pocet+0.)
# relativni odchylka od prumeru a relativni smerodatna odchylka
# math.pi vola hodnotu cisla pi
vysledek = 2./math.pi                 
odchylka = np.abs(prumer/vysledek - 1.)
smodch = np.sqrt((1./vysledek - 1.)/pocet)

# nechame vypsat vysledek na obrazovku
print("Prumer: {}, relativni smodch: {}, relativni odchylka od prumeru: {}.".format(prumer, smodch, odchylka))
